import * as observableArray from "tns-core-modules/data/observable-array";
import { Property, View } from "tns-core-modules/ui/core/view";
import * as observableModule from "tns-core-modules/data/observable";
export declare enum AutoCompleteDisplayMode {
    Tokens = "Tokens",
    Plain = "Plain"
}
export declare enum AutoCompleteSuggestMode {
    Suggest = "Suggest",
    Append = "Append",
    SuggestAppend = "SuggestAppend"
}
export declare enum AutoCompleteLayoutMode {
    Horizontal = "Horizontal",
    Wrap = "Wrap"
}
export declare enum AutoCompleteCompletionMode {
    StartsWith = "StartsWith",
    Contains = "Contains"
}
export declare enum AutoCompleteViewType {
    ItemView = "ItemView"
}
export declare class SuggestionView extends View {
    private _owner;
    suggestionViewHeight: number;
    suggestionItemTemplate: string;
    constructor();
    readonly android: any;
    readonly _nativeView: any;
    owner: RadAutoCompleteTextView;
    protected updateView(): void;
    static suggestionViewHeightProperty: Property<SuggestionView, number>;
    private onSuggestionViewHeightPropertyChanged;
    protected onSuggestionViewHeightChanged(oldValue: number, newValue: number): void;
    static suggestionItemTemplateProperty: Property<SuggestionView, string>;
    private onSuggestionItemTemplatePropertyChanged;
    protected onSuggestionItemTemplateChanged(oldValue: string, newValue: string): void;
}
export declare class TokenModel {
    image: string;
    text: string;
    constructor(text: string, image: string);
    readonly android: any;
    readonly ios: any;
    toString(): string;
}
export declare class ClearButton extends View {
}
export declare class TokenClearButton extends View {
}
export declare class Token extends View {
    readonly clearButton: ClearButton;
}
export declare class NoResultsLabel extends View {
}
export declare class CollectionViewEventData implements observableModule.EventData {
    private _eventName;
    private _object;
    private _index;
    private _groupIndex;
    private _data;
    private _returnValue;
    private _view;
    private _android;
    private _ios;
    constructor();
    android: any;
    ios: any;
    eventName: string;
    object: any;
    index: number;
    groupIndex: number;
    data: any;
    returnValue: any;
    view: View;
}
export declare class AutoCompleteEventData implements observableModule.EventData {
    private _eventName;
    private _object;
    private _token;
    private _text;
    constructor(object: any, eventName: string, text: string, token: TokenModel);
    eventName: string;
    text: string;
    token: TokenModel;
    object: any;
}
export declare class RadAutoCompleteTextView extends View {
    static textChangedEvent: string;
    static tokenRemovedEvent: string;
    static tokenAddedEvent: string;
    static tokenSelectedEvent: string;
    static tokenDeselectedEvent: string;
    static didAutoCompleteEvent: string;
    static suggestionViewBecameVisibleEvent: string;
    static itemLoadingEvent: string;
    loadSuggestionsAsync: any;
    items: observableArray.ObservableArray<TokenModel>;
    displayMode: AutoCompleteDisplayMode;
    completionMode: AutoCompleteCompletionMode;
    layoutMode: AutoCompleteLayoutMode;
    suggestMode: AutoCompleteSuggestMode;
    hint: string;
    text: string;
    minimumCharactersToSearch: number;
    tokenItemSpacing: number;
    noResultsText: string;
    showCloseButton: boolean;
    closeButtonImageSrc: string;
    suggestionView: SuggestionView;
    private _itemViewLoader;
    readOnly: boolean;
    _tokens: Array<Token>;
    _ngKey: any;
    _vueKey: any;
    private _autoCompleteFocusHandler;
    private _autoCompleteBlurHandler;
    constructor();
    itemViewLoader: (viewType: any) => View;
    readonly filteredItems: Array<TokenModel>;
    readonly selectedTokens: Array<TokenModel>;
    readonly clearButton: ClearButton;
    readonly noResultsLabel: NoResultsLabel;
    _updateAutoCompleteFocusBlurHandlers(subscribe: boolean): void;
    static loadSuggestionsAsyncProperty: Property<RadAutoCompleteTextView, any>;
    private onLoadSuggestionsAsyncPropertyChanged;
    protected onLoadSuggestionsAsyncChanged(oldValue: any, newValue: any): void;
    protected onItemViewLoaderChanged(): void;
    protected resolveTemplateView(template: string): View;
    private _getDefaultItemContent;
    getViewForViewType(viewType: any): any;
    static itemsProperty: Property<RadAutoCompleteTextView, observableArray.ObservableArray<TokenModel>>;
    private onItemsPropertyChanged;
    protected onItemsChanged(oldValue: observableArray.ObservableArray<TokenModel>, newValue: observableArray.ObservableArray<TokenModel>): void;
    static suggestionViewProperty: Property<RadAutoCompleteTextView, SuggestionView>;
    private onSuggestionViewPropertyChanged;
    protected onSuggestionViewChanged(oldValue: SuggestionView, newValue: SuggestionView): void;
    static displayModeProperty: Property<RadAutoCompleteTextView, AutoCompleteDisplayMode>;
    private onDisplayModePropertyChanged;
    protected onDisplayModeChanged(oldValue: AutoCompleteDisplayMode, newValue: AutoCompleteDisplayMode): void;
    static completionModeProperty: Property<RadAutoCompleteTextView, AutoCompleteCompletionMode>;
    private onCompletionModePropertyChanged;
    protected onCompletionModeChanged(oldValue: AutoCompleteCompletionMode, newValue: AutoCompleteCompletionMode): void;
    static layoutModeProperty: Property<RadAutoCompleteTextView, AutoCompleteLayoutMode>;
    private onLayoutModePropertyChanged;
    protected onLayoutModeChanged(oldValue: AutoCompleteLayoutMode, newValue: AutoCompleteLayoutMode): void;
    static suggestModeProperty: Property<RadAutoCompleteTextView, AutoCompleteSuggestMode>;
    private onSuggestModePropertyChanged;
    protected onSuggestModeChanged(oldValue: AutoCompleteSuggestMode, newValue: AutoCompleteSuggestMode): void;
    static hintProperty: Property<RadAutoCompleteTextView, string>;
    private onHintPropertyChanged;
    protected onHintChanged(oldValue: string, newValue: string): void;
    static textProperty: Property<RadAutoCompleteTextView, string>;
    private onTextPropertyChanged;
    protected onTextChanged(oldValue: string, newValue: string): void;
    static minimumCharactersToSearchProperty: Property<RadAutoCompleteTextView, number>;
    private onMinimumCharactersToSearchPropertyChanged;
    protected onMinimumCharactersToSearchChanged(oldValue: number, newValue: number): void;
    static tokenItemSpacingProperty: Property<RadAutoCompleteTextView, number>;
    private onTokenItemSpacingPropertyChanged;
    protected onTokenItemSpacingChanged(oldValue: number, newValue: number): void;
    static noResultsTextProperty: Property<RadAutoCompleteTextView, string>;
    private onNoResultsTextPropertyChanged;
    protected onNoResultsTextChanged(oldValue: string, newValue: string): void;
    static showCloseButtonProperty: Property<RadAutoCompleteTextView, boolean>;
    private onShowCloseButtonPropertyChanged;
    protected onShowCloseButtonChanged(oldValue: boolean, newValue: boolean): void;
    static closeButtonImageSrcProperty: Property<RadAutoCompleteTextView, string>;
    private onCloseButtonImageSrcPropertyChanged;
    protected onCloseButtonImageSrcChanged(oldValue: string, newValue: string): void;
    static readOnlyProperty: Property<RadAutoCompleteTextView, boolean>;
    private onReadOnlyPropertyChanged;
    protected onReadOnlyChanged(oldValue: boolean, newValue: boolean): void;
    resetAutoComplete(): void;
    addToken(token: TokenModel): void;
    insertTokenAtIndex(token: TokenModel, index: number): void;
    removeToken(token: TokenModel): void;
    removeTokenAtIndex(index: number): void;
    removeAllTokens(): void;
    tokens(): void;
    tokenAtIndex(index: number): any;
    findSuggestions(): void;
    eachChild(callback: (child: View) => boolean): void;
}
export declare function setupCssScope(scopedView: any, unscopedView: any): void;
